#Include "windows.bi"
#Include Once "MD5Checksum.bas"

Type tMD5 As ZString * 32

Extern "Windows-MS"

Function FileCreateMD5(ByVal sFile As String, ByVal zMD5 As tMD5 Ptr) As Integer Export
	
	Dim As UInteger nLength = Len(sFile)
	If nLength = 0 Then
		*zMD5 = "no specified file"
		Return 1
	EndIf
	
	Dim As Integer FFF = FreeFile
	If Open(sFile For Binary Access Read As #FFF) <> 0 Then
		*zMD5 = "file not found"
		Return 2
	EndIf
	
	Dim As UInteger fileLength = Lof(FFF)
	If fileLength = 0 Then
		Close #FFF
		*zMD5 = "file not found"
		Return 3
	EndIf
	
	Dim As UByte buffer(16384)
	Dim As UInteger toBuffer
	Dim As MD5Checksum MD5
	Do Until fileLength = 0
		If fileLength >= 16384 Then
			fileLength -= 16384
			toBuffer = 16384
		Else
			toBuffer = fileLength
			fileLength = 0
		EndIf
		Get #FFF, , buffer(0), toBuffer
		MD5.Update(@buffer(0), toBuffer)
	Loop
	Close #FFF
	
	*zMD5 = MD5.Final()

	Return 0
End Function

End Extern